;Copyright (c) 1999 Matthew Belmonte
;code excerpted from fastshft.asm by Matthew Belmonte
;see also istart.asm, istop.asm
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
TITLE	  COMREAD		READ A BYTE FROM THE SERIAL PORT AND DISPLAY IT
CODESG	  SEGMENT PARA 'Code'
	  ASSUME CS:CODESG,DS:CODESG,SS:CODESG,ES:CODESG
	  ORG 100H		;START AT END OF PSP
MAIN:	  MOV DS,0040H		;BIOS SEGMENT
	  MOV DX,[00H]		;GET ADDRESS OF BASE SERIAL PORT (COM1)
	  MOV BX,[10H]		;GET DEVICE COUNTS
	  AND BH,0CH		;MASK FOR HIGH-ORDER BITS OF SERIAL PORT COUNT
	  JE ONEPORT		;IF MORE THAN ONE SERIAL PORT IS INSTALLED,
	  MOV DX,[02H]		;GET ADDRESS OF FIRST EXPANSION PORT (COM2)
ONEPORT:  ADD DX,5		;POINT TO LINE STATUS REGISTER
WAITLOOP: IN AL,DX		;GET STATUS
	  TEST AL,01H		;MASK FOR 'DATA AVAILABLE' FLAG
	  JE WAITLOOP		;WAIT TILL AVAILABLE
	  SUB DX,5		;POINT BACK AT DATA REGISTER
	  IN AL,DX		;GET DATA
	  MOV CH,AL		;SAVE A COPY OF IT
	  MOV AH,0		;ZERO HIGH-ORDER DATA BITS

	  LEA BX,MESSAGE	;POINT TO OUTPUT BUFFER
	  MOV DH,100		;SEE HOW MANY HUNDREDS
	  DIV DH
	  TEST AL,0FFH		;DON'T PRINT HUNDREDS DIGIT IF < 100
	  JE NOHUNDS
	  ADD AL,'0'		;MAKE IT INTO A DIGIT
	  MOV [BX],AL		;PUT IT INTO THE BUFFER
	  INC BX
	  MOV AL,AH		;MOVE REMAINDER INTO LOW BYTE
	  MOV AH,0		;ZERO HIGH BYTE
	  MOV DH,10		;SEE HOW MANY TENS
	  DIV DH
TENS:	  ADD AL,'0'		;MAKE IT INTO A DIGIT
	  MOV [BX],AL		;PUT IT INTO THE BUFFER
	  INC BX
NOTENS:	  ADD AH,'0'		;MAKE UNITS INTO A DIGIT
	  MOV [BX],AH		;PUT IT INTO THE BUFFER
	  INC BX
	  MOV CL,' '
	  MOV [BX],CX		;PRINT A SPACE AND THE ORIGINAL CHARACTER
	  ADD BX,2
	  MOV CX,0A0D		;END LINE WITH CR-LF
	  MOV [BX],CX
	  ADD BX,2
	  MOV CX,BX		;MAKE CX CONTAIN LENGTH AND BX POINT TO START
	  LEA DX,MESSAGE
	  SUB CX,DX
	  MOV BX,1		;FILE HANDLE 1 (STDOUT)
	  MOV AH,40H		;WRITE
	  INT 21H
	  MOV AX,4C00H		;SUCCESSFUL COMPLETION
	  INT 21H		;RETURN TO MSDOS
NOHUNDS:  MOV AL,AH		;MOVE REMAINDER INTO LOW BYTE
	  MOV AH,0		;ZERO HIGH BYTE
	  MOV DH,10		;SEE HOW MANY TENS
	  DIV DH
	  TEST AL,0FFH		;DON'T PRINT TENS DIGIT IF < 10
	  JE NOTENS
	  JMP TENS
MESSAGE	  DB ?,?,?,?,?,?,?	;OUTPUT BUFFER
	  ENDP
CODESG	  ENDS
	  END  MAIN
