;Copyright (c) 2000 by Matthew Belmonte <mkb4@Cornell.edu>.
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
TITLE	  JOYCAL		CALIBRATE JOYSTICK TIMER AGAINST VIDEO REFRESH
CODESG	  SEGMENT PARA 'Code'
	  ASSUME CS:CODESG,DS:CODESG,SS:CODESG,ES:CODESG
	  ORG 100H		;START AT END OF PSP

SYNCREG	  EQU 3DAH		;COLOUR SYNC REGISTER

MAIN:	  MOV DX,SYNCREG
	  MOV CX,0		;ZERO COUNTER
	  PUSHF			;SAVE INTERRUPT MASK
	  CLI			;MASK INTERRUPTS
SYNC0:	  IN AL,DX
	  TEST AL,8H
	  JNE SYNC0		;WAIT TILL SYNC LOW
SYNC1:	  IN AL,DX
	  TEST AL,8H
	  JE SYNC1		;WAIT TILL RISING EDGE OF SYNC
WAIT0:	  INC CX		;INCREMENT COUNTER
	  JE OVERFLOW
	  IN AL,DX		;GET STATUS
	  TEST AL,8H
	  JNE WAIT0		;LOOP TILL SYNC LOW
WAIT1:	  INC CX
	  JE OVERFLOW
	  IN AL,DX
	  TEST AL,8H
	  JE WAIT1
OVERFLOW: POPF			;RESTORE INTERRUPT MASK
	  MOV AX,CX		;MOVE COUNT INTO AX
	  MOV CX,10000		;INITIAL DIVISOR IS 10^4
PRNTDIG:  MOV DX,0		;HIGH BITS OF DIVIDEND ARE ZERO
	  DIV CX		;QUOTIENT IN AL, ZERO IN AH, REMAINDER IN DX
	  PUSH DX		;SAVE REMAINDER
	  PUSH CX		;SAVE DIVISOR
	  ADD AL,'0'		;MAKE THE QUOTIENT INTO A DIGIT
	  MOV DIG,AL		;PUT IT IN THE DISPLAY AREA
	  LEA DX,DIG		;POINT TO IT
	  MOV AH,40H		;OUTPUT IT
	  MOV BX,1		;TO FILE HANDLE 1 (STDOUT)
	  MOV CX,1		;AS A SINGLE CHARACTER
	  INT 21H
	  POP AX		;RESTORE DIVISOR INTO AX
	  MOV DX,0
	  MOV CX,10		;DIVIDE IT BY TEN
	  DIV CX		;NEW DIVISOR IN AX, 0 (OR 1, ON LAST LOOP) IN DX
	  MOV CX,AX		;MOVE DIVISOR BACK INTO CX
	  POP AX		;RESTORE REMAINDER INTO AX
	  TEST CX,0FFFFH
	  JNE PRNTDIG		;LOOP TILL DIVISOR IS ZERO
	  LEA DX,CRLF		;END-OF-LINE
	  MOV AH,40H
	  MOV BX,1
	  MOV CX,2
	  INT 21H
	  MOV AX,4C00H		;SUCCESSFUL COMPLETION
	  INT 21H		;RETURN TO MSDOS
DIG	  DB ?			;SPACE TO STORE DIGIT
CRLF	  DB 13			;CR
	  DB 10			;LF
	  ENDP
CODESG	  ENDS
	  END MAIN
