;Copyright (c) 1999 by Matthew Belmonte <mkb4@Cornell.edu>.
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
TITLE	  JOYMON		JOYSTICK INPUT PORT MONITOR
CODESG	  SEGMENT PARA 'Code'
	  ASSUME CS:CODESG,DS:CODESG,SS:CODESG,ES:CODESG
	  ORG 100H		;START AT END OF PSP

SYNCREG	  EQU 3DAH		;COLOUR SYNC REGISTER
GAMEPORT  EQU 201H		;GAME PORT
B1MASK	  EQU 10H		;SWITCH ON PINS 2 AND 4
B2MASK	  EQU 20H		;SWITCH ON PINS 7 AND 4

MAIN:	  CLI
	  MOV AX,0013H
	  INT 10H
	  MOV DS,0A000H
	  MOV BX,320*200-1
CLSLOOP:  MOV BYTE PTR [BX],0
	  DEC BX
	  JNE CLSLOOP
	  MOV BYTE PTR [BX],0
	  MOV DS,CS
	  MOV DX,GAMEPORT
BUTTWAIT: IN AL,DX
	  AND AL,B1MASK
	  JNE BUTTWAIT
	  MOV BUTTON,AL
CALLSYNC: CALL JOYSYNC
	  JMP CALLSYNC

JOYSYNC:  MOV DX,GAMEPORT	;CHECK IF EXACTLY ONE BUTTON DOWN
	  IN AL,DX
	  AND AL,B1MASK+B2MASK
	  JP JOYSYNC1
	  MOV AH,AL		;CHECK IF BUTTON CHANGED
	  XOR AH,BUTTON
	  JE JOYSYNC1
	  MOV BUTTON,AL
	  MOV DS,0A000H		;IF SO, SET PIXEL
	  MOV AL,0FH
	  MOV [BX],AL
	  INC BX
	  MOV DS,CS
	  JMP SYNC1
JOYSYNC1: MOV DX,SYNCREG	;COLOUR SYNC REGISTER
JOYSYNC2: IN AL,DX
	  AND AL,8H		;VSYNC
	  JNE JOYSYNC		;LOOP TILL VSYNC LOW
JOYSYNC3: MOV DX,GAMEPORT
	  IN AL,DX
	  AND AL,B1MASK+B2MASK
	  JP JOYSYNC4
	  MOV AH,AL		;CHECK IF BUTTON CHANGED
	  XOR AH,BUTTON
	  JE JOYSYNC4
	  MOV BUTTON,AL
	  MOV DS,0A000H		;IF SO, SET PIXEL
	  MOV AL,0FH
	  MOV [BX],AL
	  INC BX
	  MOV DS,CS
	  JMP SYNC2
JOYSYNC4: MOV DX,SYNCREG
	  IN AL,DX
	  AND AL,8H
	  JE JOYSYNC3		;LOOP TILL VSYNC RISES
	  RET

SYNC:	  MOV DX,SYNCREG	;COLOUR SYNC REGISTER
SYNC1:	  IN AL,DX
	  AND AL,8H		;VSYNC
	  JNE SYNC1		;LOOP TILL VSYNC LOW
SYNC2:	  MOV DX,SYNCREG	;COLOUR SYNC REGISTER
SYNC3:	  IN AL,DX
	  AND AL,8H
	  JE SYNC3		;LOOP TILL VSYNC RISES
	  RET

BUTTON	  DB ?
	  ENDP
CODESG	  ENDS
	  END MAIN
