#define NUM_STIMULI 1072 /*1072 * 56msec/stim = 60sec*/
#define NUM_TRIALS 30	/*30 trials in the experiment*/
#define EV_START 5	/*start of trial; 5=attend left, 6=attend right*/
#define EV_FINISH 7	/*end of trial*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/*a random real number in the interval [0,1]*/
double random01()
  {
  return((random()&((1L<<30)-1))/(double)((1L<<30)-1));
  }

int main()
  {
  register int tick, trial;
  int side;	/*0 if this is an attend-left trial, 1 if attend-right*/
  double target0, target1, ign_target0, ign_target1;
  char stimuli[NUM_STIMULI+1];
  trial = NUM_TRIALS;
  while(trial--)
    {
    side = (random01() < 0.5);
    printf("%d\n", EV_START+side);
    target0 = random01();
    target1 = random01();
    if(target0 < 0.05)
      target0 = 18.0*(target0/0.05);
    else
      target0 = 18.0 + 30.0*((target0-0.05)/0.95);
    if(target1 < 0.05)
      target1 = target0 + 12.0*(target1/0.05);
    else
      target1 = (target0+12.0) + (60.0-(target0+12.0))*((target1-0.05)/0.95);
    do
      {
      ign_target0 = random01();
      if(ign_target0 < 0.05)
	ign_target0 = 18.0*(ign_target0/0.05);
      else
	ign_target0 = 18.0 + 30.0*((ign_target0-0.05)/0.95);
      }while((fabs(ign_target0 - target0) < 1.2)
	  || (fabs(ign_target0 - target1) < 1.2));
    do
      {
      ign_target1 = random01();
      if(ign_target1 < 0.05)
	ign_target1 = ign_target0 + 12.0*(ign_target1/0.05);
      else
	ign_target1 = (ign_target0+12.0) + (60.0-(ign_target0+12.0))*((ign_target1-0.05)/0.95);
      }while((fabs(ign_target1 - target1) < 1.2)
	  || (fabs(ign_target1 - target0) < 1.2)
	  || (fabs(ign_target1 - ign_target0) < 1.2));
    for(tick = 0; tick != NUM_STIMULI; tick++)
      {
      stimuli[tick] = 2*side+1;
      side = !side;
      }
    tick = (int)(target0/0.056);
    if(tick&1)
      tick++;
    stimuli[tick]++;
    tick = (int)(target1/0.056);
    if(!(tick&1))
      tick++;
    stimuli[tick]++;
    tick = (int)(ign_target0/0.056);
    if(!(tick&1))
      tick++;
    stimuli[tick]++;
    tick = (int)(ign_target1/0.056);
    if(tick&1)
      tick++;
    stimuli[tick]++;
    for(tick = 0; tick != NUM_STIMULI; tick++)
      printf("%d\n", stimuli[tick]);
    printf("%d\n", EV_FINISH);
    }
  return 0;
  }
